namespace KAccelGen

# namespace KAccelGen | Provides functions that, given a collection of QStrings, will automatically and intelligently assign menu accelerators to the QStrings in the collection. More...
List of all Methods
Annotated List
Files
Globals
Hierarchy
Index

#### Public Types

- class Deref
- class Deref_Key

#### Public Methods

- inline bool isLegalAccelerator (const QString& str, uint index)
- template inline void loadPredefined (Iter begin, Iter end, QMap<QChar,bool>& keys)
- template void generate (Iter begin, Iter end, QStringList& target)
- template inline void generateFromKeys (Iter begin, Iter end, QStringList& target)

## Detailed Description

Provides functions that, given a collection of QStrings, will automatically and intelligently assign menu accelerators to the QStrings in the collection.

NOTE: When this file speaks of "accelerators", we really mean accelerators as defined by the KDE User Interface Guidelines. We do NOT mean "shortcuts", which are what's handled by most other KDE libraries with "accel" in the name.

In the Qt library, the mechanism for adding a keyboard accelerator to a menu item is to insert an '&' before the letter. Since we usually don't want to disturb the original collection, the idiom in these functions is to populate a "target" QStringList parameter with the input collectin's QStrings, plus possibly some added '&' characters.

That is the mechanism. Here is the policy, in order of decreasing importance (it may seem like these are implementation details, but IMHO the policy is an important part of the interface):

1. If the string already contains an '&' character, skip this string, because we consider such strings to be "user-specified" accelerators.

2. No accelerator may clash with a previously defined accelerator, including any legal (alphanumeric) user-specified accelerator anywhere in the collection

3. Prefer alphanumerics at the start of the string.

4. Otherwise, prefer alphanumerics at the start of a word.

5. Otherwise, choose any alphanumeric character not already taken. If no such character is available, give up & skip this string.

A typical use of these functions would be to automatically assign accelerators to a dynamically populated popup menu. For example, the core code was written to automatically set accelerators for the "Load View Profile" popup menu for Konqueror. We quickly realized that it would be useful to make this facility more generally available, so I abstracted it out into a set of templates.

TODO:

+ Add sugar functions for more collections.

+ Add more Deref classes so that we can access a wider variety of collections.

Deref (class) | ### Deref

Static dereference class, for use as a template parameter.

Deref_Key (class) | ### Deref_Key

Static dereference class that calls the key() method on its target; for use as a template parameter.

inline bool isLegalAccelerator (const QString& str, uint index) | ### isLegalAccelerator

Helper to determine if the given offset in the string could be a legal alphanumeric accelerator.

Parameters:

str | base string
index | offset to check

template inline void loadPredefined (Iter begin, Iter end, QMap<QChar,bool>& keys) | ### loadPredefined

Loads all legal predefined accelerators in the (implicitly specified) collection into the given QMap.

Parameters:

begin | start iterator
end | (last+1) iterator
keys | map to store output

template void generate (Iter begin, Iter end, QStringList& target) | ### generate

Main, maximally flexible template function that assigns accelerators to the elements of a collection of QStrings. Clients will seldom use this directly, as it's usually easier to use one of the wrapper functions that simply takes a collection (see below).

The Deref template parameter is a class containing a static dereferencing function, modeled after the comparison class C in Stroustrup 13.4.

Parameters:

begin | (you know)
end | (you know)
target | collection to store generated strings

template inline void generateFromKeys (Iter begin, Iter end, QStringList& target) | ### generateFromKeys

Another convenience function; looks up the key instead of dereferencing directly for the given iterator.

Parameters:

target |

Generated by: root on macppc.ports.openbsd.org on Sat Sep 6 10:36:37 2003, using kdoc 2.0a54.